<?php
	define("COPY_FILE","Copy");
	define("CREATE_FILE","Create");
// trivial 'thingy' object to handle 'to' and 'from' manipulation
// methods - 
//   'where' - vets supplied params and determines location (web/dir)
//   'open' - opens directories as required by location
//   'read' - redas directories and timestamps into a supplied array
//   'sync_dir' - deletes excess directories & files on 'to'
//   'update_dirs' - creates required directories on 'to'
//   'update_files' - deletes excess files on 'to'
//   'sync_files' - copies files as required to 'to'
//   'up' - positions up one directory (on change of LEVEL)
//   'down' - goes down a directory depending on  LEVEL
//   'close' - closes open connections as required
// Properties
//   'down_only' - forces us down a LEVEL (i.e. no 'up')
//   'copied' count of copied files
//   'created' count of new files
//   'new_dirs' count of created directories
//   'ftp' ftp session id if remote
class thingy
{
var $base;
var $user;
var $password;
var $type;
var $dir;
var $ftp;
var $open;
var $spacer;
var $down_only;
var $copies;
var $created;
var $new_dirs;
var $files_read;
var $dots;
var $dirs_read;
var $del_dirs;
var $del_files;
var $op;
function thingy()
{
	// constructor (initialise)
	$this->open = false;
	$this->type = "dir";	// default value maybe set to web by 'where' function
	$this->spacer = "";	// 
	$this->down_only = false;	// set externally
	$this->copied = 0; // no. of files copied
	$this->created = 0; // no. of fles created
	$this->new_dirs = 0;	// no. of directories created
	$this->files_read =0;	// no. of files read by this object
	$this->dirs_read = 0; // no. of direcotires read by this object
	$this->del_dirs = 0; // no of directories delete by this object
	$this->del_files = 0; // no of file deleted by this object
}
function close()
{
	// close session if web - else do nothing
	if($this->type == "web" and $this->open){
		ftp_quit($this->ftp);
	}
}
function copy_it(&$fr, $file, $type)
{
	// copy or create file in current directory
	// fr = from object, file = filename, type = copy or create
	if($this->type == "dir"){
		if($fr->type == "dir"){
			// 'from' = local 'to' = local
			// echo "From local->local<br>\n";
			if(!(copy($fr->base.$fr->spacer."/".$file, $this->base.$this->spacer."/".$file))){
				return false;
			}
		}else{
			// 'from' = web 'to' = local
			// echo "From web->local<br>\n";
			if(!(ftp_get($fr->ftp,$this->base.$this->spacer."/".$file,$file,FTP_ASCII))){
				return false;
			}
		}
	}elseif($fr->type == "dir"){
		// 'from' = local 'to' = web
		// echo "From local->web ".$file." From ".$fr->base.$fr->spacer."/".$file."<br>\n";
		if(!(ftp_put($this->ftp,$file,$fr->base.$fr->spacer."/".$file, FTP_ASCII))){
			echo "Failed From local->web ".$file." From ".$fr->base.$fr->spacer."/".$file."<br>\n";
			return false;
		}
	}else{
		// 'from' = web 'to' = web
		echo "From web->web - not supported<br>\n";
		return false;
	}
	echo $type." file ".$this->base.$this->spacer."/".$file."<br>\n";
	return true;
}
function delete_dir($dir)
{
	// deletes '$dir' directory and all sub directories 
	// and all files in each directory
	// echo "Delete ".$dir."<br>\n";
	$temp_dirs[0] = "";
	$temp_files[0][0] = "";
	$temp_master[] = MAGIC_NUMBER;
	$temp_dir = $dir;
	$this->down_only = true;
	while(count($temp_master) != 0){
		if($this->down($temp_dir) == false){
			echo "Fail down<br>\n";
			return false;
		}
		if($this->read($temp_dirs,$temp_files) == false){
			echo "Fail read<br>\n";
			return false;
		}
		$my_file_count = count($temp_files);
		// echo "Del file count = ".$my_file_count."<br>\n";
		if(count($my_file_count) != 0){
			// delete all files
			for($i=0;$i<$my_file_count;$i++){
				// echo "Delete file = ".$temp_files[$i][0]."<br>\n";
				if($this->type == "web"){
					if(ftp_delete($this->ftp,$temp_files[$i][0]) == false){
						return false;
					}
				}else{
					// echo "local error<br>\n";
					unlink($this->base.$this->spacer."/".$temp_files[$i][0]);
				}
				$this->del_files++;
			}
		}
		// echo "Dir count = ".count($temp_dirs)."<br>\n";
		if(count($temp_dirs) != 0){
			// replace current dir on stack 'cos we can't delete until empty
			array_push($temp_master, $temp_dir);	// replace on master array
			array_push($temp_master, "LEVEL117XDB");
			$temp_master = array_merge($temp_master,$temp_dirs);
			$this->down_only = true;
			// print_r($temp_master);
		}else{
			// we have no new directories so we can delete this directory
			// echo "Delete dir ".$temp_dir."<br>\n";
			if($this->up() == false){
				return false;
			}
			$this->down_only = true;
			echo "Delete dir =".$this->base.$this->spacer."/".$temp_dir."<br>\n";
			if($this->type == "web"){
				if(ftp_rmdir($this->ftp,$temp_dir) == false){
					return false;
				}
			}else{
				if(rmdir($this->base.$this->spacer."/".$temp_dir) == false){
					return false;
				}
			}
			$this->del_dirs++;
		}
		while(count($temp_master) != 0){
			$temp_dir = array_pop($temp_master);
			// echo "Current = ".$temp_dir."<br>\n";
			if($temp_dir == "LEVEL117XDB"){
				if($this->up() == false){
					return false;
				}
			}else{
				break;
			}
		}		
	}
	return true;
}
function down($dir)
{
	// position directory pointer
	// we go up one and then down to 'dir' unless 'down_only' = true
	// returns true = ok else = false
	if($this->type == "web" and $this->down_only == false){
		// up one
		if(!(ftp_cdup($this->ftp))){
			return false;
		}
	}
	if($this->type == "web"){
		if(!(ftp_chdir($this->ftp,$dir))){
			return false;
		}
		$temp_name = ftp_pwd($this->ftp);
		// echo "Web= ".$temp_name."<br>\n";
	}
	// rewind spacer
	if($this->down_only == false){
		$temp_ar = explode("/",$this->spacer);
		$this->spacer = "";
		if(count($temp_ar) > 1){
			$temp_count = count($temp_ar) -1;
			for($i = 0; $i<$temp_count;$i++){
				if($temp_ar[$i] != ""){
					$this->spacer = $this->spacer."/".$temp_ar[$i];
				}
			}
		}
	}else{
		$this->down_only = false;
	}
	
	$this->spacer = $this->spacer."/".$dir;
	// echo "Down spacer= ".$this->spacer."<br>\n";
	return true;
}
function open()
{
	// open and position the directories
	// returns true = ok else = false
	// this->base already has the directory parameter
	if($this->type == "web"){
		// open ftp session
		// 'where' function has broken base into sub directory structure for web
		// to allow us to position the ftp directory pointer one level at a time
		if($this->ftp = ftp_connect($this->dir[0])){
			if(ftp_login($this->ftp,$this->name,$this->pass)){
				$this->open = true;	// mark open
				// do any positioning
				$count = count($this->dir);
				// echo "Count= ".$count."<br>\n";
				if($count > 1){
					for($i = 1;$i < $count;$i++){
						if(ftp_chdir($this->ftp,$this->dir[$i]) == false){
							// create the directory if it does not exist
							echo "Created directory =  ".$this->dir[$i]."<br>\n";
							if(ftp_mkdir($this->ftp, $this->dir[$i]) == false){
								return false;
							}
							// now position here
							$this->new_dirs++;
							if(ftp_chdir($this->ftp,$this->dir[$i]) == false){
								return false;
							}
						}
					}
				}
			}else{
				// failed to login
				echo "Login error - password etc. correct?<br>\n";
				return false;
			}
		}else{
			// fail to open
			echo "Open ftp error - address correct?<br>\n";
			return false;
		}
	}else{
		// local directory
		// we dont create the directory for local
		// echo "Base dir = ".$this->base."<br>\n";
		if(chdir($this->base) == false)
		{
			return false;
		}
	}
	return true;
}
function read(&$dir_array, &$file_array)
{
	// read and separate files and directories from current pointer
	// returns true = ok else = false
	// dir_array = existing array of directory names, file_array = existsing array of file names
	array_splice($dir_array,0);
	array_splice($file_array,0);
	if($this->type == "web"){
		// ftp format
		$work_array = ftp_nlist($this->ftp, ".");
		if(is_array($work_array)){
			$work_count = count($work_array);
			$j = 0;
			for ($i = 0;$i<$work_count;$i++){
				list(,$temp) = each($work_array);
				if(ftp_size($this->ftp,$temp) != -1){
					$file_array[$j][0] = $temp;
					$file_array[$j][1] = ftp_mdtm($this->ftp,$temp);
					$j++;
					$this->files_read++;
				}else{
					$dir_array[] = $temp;
					$this->dirs_read++;
				}
			}
		}
	}else{
		// local directory
		// echo "Dir = ".$this->base.$this->spacer."<br>\n";
		if(chdir($this->base.$this->spacer) == false){
			return false;
		}
		$my_dir = opendir($this->base.$this->spacer);
		$i = 0;
		while(($file = readdir($my_dir)) !== false){
			if($file != "." and $file != ".."){
				if(is_dir($file)== true){
					$dir_array[] = $file;
					$this->dirs_read++;
				}else{
					$file_array[$i][0] = $file;
					$file_array[$i][1] = filemtime($this->base.$this->spacer."/".$file);
					$i++;
					$this->files_read++;
				}
			}
		}
		closedir($my_dir);
	}
	return true;
}

function sync_dirs(&$from_dirs, &$to_dirs)
{
	// synchronise directories
	// if directory in 'to' but not 'from' we delete 'to' and all levels below
	// from_dirs = array of directory in source (from), to_dirs = array of directories in destination (to)
	// now check for synchronisation required if not we exit
	if($this->op == "sync"){
		// sync processing 
		
		$count_to = count($to_dirs);
		$count_from = count($from_dirs);
		if(!is_array($to_dirs)){
			$count_to = 0;
		}
		if(!is_array($from_dirs)){
			$count_from = 0;
		}
		// echo "Counts f= ".$count_from." t= ".$count_to."<br>\n";
		if($count_from == 0 && $count_to == 0){
			return true;
		}
		if($count_to == 0){
			return true;
		}
		if($count_from == 0){
			// delete all dirs and sub files
			reset($to_dirs);
			while(list(,$temp) = each($to_dirs)){
				// echo "Delete dir= ".$temp."<br>\n";
				if($this->delete_dir($temp) == false){
					return false;
				}
			}
			return true;
		}else{
			// update processing
			// we take 'to' and if we don't find in 'from' we delete it
			reset($to_dirs);
			while(list(,$temp) = each($to_dirs)){
				// exhaustive search - crude
				$not_found = true;
				reset($from_dirs);
				while(list(,$target) = each($from_dirs)){
					if($temp == $target){
						$not_found = false;
					}
				}
				if($not_found){
					// delete directory and all sub-dirs
					// echo "Delete directory = ".$temp."<br>\n";
					if($this->delete_dir($temp) == false){
						return false;
					}
				}
			}
		}
	}
	return true;
}
function sync_files(&$from_files, &$to_files)
{
	// synchonise files if op != sync we exit
	// 1. if file in 'to' but not 'from' we delete it 
	// from_files = array of 'from' files, to_files = array of 'to' files
	if($this->op == "sync"){
		// sync processing
		// if file in 'to' but not in 'from' we delete it
		$to_file_count = count($to_files);
		if(!is_array($to_files)){
			$to_file_count = 0;
		}
		$from_file_count = count($from_files);
		if(!is_array($from_files)){
			$from_file_count = 0;
		}
		if($to_file_count == 0 && $from_file_count == 0){
			return true;
		}
		if($to_file_count == 0){
			// bit oscure but if we had no files in 'to' then after update we will
			// have only the right ones so we just exit
			return true;
		}
		if($from_file_count == 0){
			// delete all files in 'to' because there are none in 'from'
			echo "delete all files in directory<br>\n";
			for($i=0;$i<$to_file_count;$i++){
				// echo "Delete file = ".$temp_files[$i][0]."<br>\n";
				if($this->type == "web"){
					if(ftp_delete($this->ftp,$to_files[$i][0]) == false){
						return false;
					}
				}else{
					unlink($this->base.$this->spacer."/".$to_files[$i][0]);
				}
				$this->del_files++;
			}
		}else{
			// 
			// we take 'to_files' and if we don't find in 'from_files' we delete it
			for($i = 0; $i<$to_file_count;$i++){
				$target = $to_files[$i][0];	// filename
				// exhaustive search - crude
				$not_found = true;
				reset($from_files);
				for($j=0;$j<$from_file_count;$j++){
					$temp = $from_files[$j][0];
					if($temp == $target){
						$not_found = false;
					}
				}
				if($not_found){
					// delete file in 'to'
					echo "Delete file = ".$target."<br>\n";
					if($this->type == "web"){
						if(ftp_delete($this->ftp,$target) == false){
							return false;
						}
					}else{
						// echo "local error<br>\n";
						unlink($this->base.$this->spacer."/".$target);
					}
					$this->del_files++;
				}
			}
		}
	}
	return true;
}
function up()
{
	// move directory pointer up 1 level
	// return true = ok false = error
	// rewind 'spacer' (the incremental change from base to current directory)
	if($this->spacer != ""){
		$temp_ar = explode("/",$this->spacer);
		$this->spacer = "";
		if(is_array($temp_ar)){
			$temp_count = count($temp_ar) -1;
			for($i = 0; $i<$temp_count;$i++){
				if($temp_ar[$i] != ""){
					$this->spacer = $this->spacer."/".$temp_ar[$i];
				}
			}
		}
		// do nothing with local directory but change pointer if web
		if($this->type == "web"){
			if(!(ftp_cdup($this->ftp))){
				return false;
			}
			// $temp_name = ftp_pwd($this->ftp);
			// echo "Up Web= ".$temp_name." Spacer= ".$this->spacer."<br>\n";
		}
	}
	return true;
}

function update_dirs(&$from, &$to)
{
	// update directories
	// this is a first pass to bring lists up to date  (method of 'to' only)
	// from = array of 'from' dirs, to = array of 'to' dirs
	while(list(,$temp) = each($from))
	{
		$not_found = true;
		reset($to);
		while(list(,$target) = each($to)) // unsorted list - exhaustive search
		{
			if($target == $temp){
				$not_found = false; // found directory - don't create
				// echo "Found ".$temp."<br>\n";
				break;
			}
		}
		if($not_found){
			echo "Create Directory ".$temp."<br>\n";
			// create directory
			$this->new_dirs++;
			if($this->type == "web"){
				if(ftp_mkdir($this->ftp, $temp) == false){
					return false;
				}
			}else{
				mkdir($this->base.$this->spacer."/".$temp,0744);
			}
		}
	}
	// reset array pointers before returning
	reset($to);
	reset($from);
	return true;
}

function update_files(&$from,&$from_files, &$to_files)
{
	// this is a first pass to bring lists up to date  (method of 'to' only)
	// from = from object (for certain params), from_files = array of 'from' files, to_file = array of 'to' files
	reset($from_files);
	reset($to_files);
	$tt_count = count($to_files);
	$tf_count = count($from_files);
	// outer loop on from file count
	for($i=0;$i<$tf_count;$i++){
		$tf_file = $from_files[$i][0];
		$tf_time = $from_files[$i][1];
		$found_it = 0;
		reset($to_files);
		// exhaustive search of to files
		// we could sort and compare to speed things up
		for($j=0;$j<$tt_count;$j++){
			$tt_file = $to_files[$j][0];
			$tt_time = $to_files[$j][1];
			if($tf_file == $tt_file){
				$found_it = 1;
				break;
			}
		}
		if($found_it){
			// found it now compare times
			if($tf_time > $tt_time){
				// copy = overwrite file
				if(!($this->copy_it($from, $tf_file,COPY_FILE))){
					return false;
				}
				$this->copied++;
			}
		}else{
			// create the file
			if(!($this->copy_it($from, $tf_file,CREATE_FILE))){
				return false;
			}
			$this->created++;
		}
	}
	return true;
}

function where($pu, $pp)
{
	// verify if local ("dir") or web ("web") and that required params exist
	// return true = ok false = any failure
	// trivial check if from/to (dir) starts '/' assumes a local directory else its web (ftp)
	// creates directory array if web
	if($this->base[0] != "/")
	{
		$this->type = "web";
		$this->dir = explode("/",$this->base);
		// echo "Count= ".count($this->dir)."<br>\n";
		// for ($i=0;$i<count($this->dir);$i++)
		// {
			//  "Dir= ".$this->dir[$i]."<br>\n";
		// }
		$this->name = $pu;
		$this->pass = $pp;
		if($this->name == "" and $this->pass == ""){
			// assume anon if both empty
			$this->name = "anonymous";
			$this->pass = "me@my.com"; // looks like an e-mail address
		}elseif($this->name != "" and $this->pass != ""){
			// both present (non-blank)
		}else{
			// one or other but not both - fail
			return  false;
		}
	}
	return  true;
}
} // end class definition
